%define gcj_support 1

Name:           gnu-crypto
Version:        2.0.1
Release:        1jpp_5fc
Epoch:          0
Summary:        GNU Crypto library for Java

Group:          Security/Cryptography
License:        GPL with library exception
URL:            http://www.gnu.org/software/gnu-crypto/
Source0:        http://ftp.gnupg.org/GnuPG/gnu-crypto/gnu-crypto-2.0.1.tar.bz2
Patch0:         %{name}-crosslink.patch
# javax.security.auth.* is already in J2SE >= 1.4.
Patch1:         %{name}-noauth.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch
BuildRequires:  ant, java-devel >= 0:1.4
%if !%{gcj_support}
Requires:       java >= 0:1.4
Requires(post): jpackage-utils >= 0:1.6.3-1jpp_1rh
Requires(postun): jpackage-utils >= 0:1.6.3-1jpp_1rh
%else
Requires:       jce
Requires:       jpackage-utils >= 0:1.6.2-1jpp_5rh
%endif
Requires:       java-sasl

%description
GNU Crypto, part of the GNU project, released under the aegis of GNU,
aims at providing free, versatile, high-quality, and provably correct
implementations of cryptographic primitives and tools in the Java
programming language for use by programmers and end-users.

%package        sasl-jdk1.4
Summary:        Gnu Crypto SASL API
Group:          Security/Cryptography
Provides:       java-sasl
%if %{gcj_support}
Requires:	libgcj >= 4.0.0-0.42
%endif

%description    sasl-jdk1.4
%{summary}.

%if %{gcj_support}
%package        jce-jdk1.4
Summary:        Gnu Crypto JCE API
Group:          Security/Cryptography
Provides:       jce
Requires:	libgcj >= 4.0.0-0.42

%description    jce-jdk1.4
%{summary}.
%endif

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildRequires:  java-javadoc

%description    javadoc
%{summary}.


%prep
%setup -q
%patch0 -p0
%if !%{gcj_support}
%patch1 -p0
%endif


%build
ant -Djdk2=true -Dj2se.apidoc=%{_javadocdir}/java jar javadoc2


%install
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d
touch $RPM_BUILD_ROOT%{_sysconfdir}/java/security/security.d/3000-gnu.crypto.jce.GnuCrypto
%endif

install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -pm 644 lib/gnu-crypto.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar
%if %{gcj_support}
install -dm 755 $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed
ln -s %{_javadir}/%{name}-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-%{version}.jar
%endif

install -dm 755 \
  $RPM_BUILD_ROOT%{_javadir}-{ext,1.4.0,1.4.1,1.4.2}
install -pm 644 lib/javax-security.jar \
  $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-sasl-jdk1.4.jar
for javaver in 1.4.0 1.4.1 1.4.2 ; do
  ln -s %{_javadir}-ext/%{name}-sasl-jdk1.4.jar \
    $RPM_BUILD_ROOT%{_javadir}-$javaver/sasl.jar
done
%if %{gcj_support}
ln -s %{_javadir}-ext/%{name}-sasl-jdk1.4.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-sasl-jdk1.4.jar
%endif

# The jce subpackage is required for libgcj which does not contain
# JCE.
%if %{gcj_support}
install -pm 644 lib/javax-crypto.jar \
  $RPM_BUILD_ROOT%{_javadir}-ext/%{name}-jce-jdk1.4.jar
for javaver in 1.4.0 1.4.1 1.4.2 ; do
  ln -s %{_javadir}-ext/%{name}-jce-jdk1.4.jar \
    $RPM_BUILD_ROOT%{_javadir}-$javaver/jce.jar
done
ln -s %{_javadir}-ext/%{name}-jce-jdk1.4.jar \
  $RPM_BUILD_ROOT%{_javadir}/gcj-endorsed/%{name}-jce-jdk1.4.jar
%endif

install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pR docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}


%check || :
# ant check # takes a looooong time


%clean
rm -rf $RPM_BUILD_ROOT


%if %{gcj_support}
%post
%{_bindir}/rebuild-security-providers

%postun
%{_bindir}/rebuild-security-providers
%endif

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}/%{name}*.jar
%if %{gcj_support}
%{_sysconfdir}/java/security/security.d/3000-gnu.crypto.jce.GnuCrypto
%{_javadir}/gcj-endorsed/%{name}-%{version}.jar
%endif

%files sasl-jdk1.4
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}-ext/%{name}-sasl-jdk1.4.jar
%{_javadir}-1.4.0/sasl.jar
%{_javadir}-1.4.1/sasl.jar
%{_javadir}-1.4.2/sasl.jar
%if %{gcj_support}
%{_javadir}/gcj-endorsed/%{name}-sasl-jdk1.4.jar
%endif

%if %{gcj_support}
%files jce-jdk1.4
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING README THANKS
%{_javadir}-ext/%{name}-jce-jdk1.4.jar
%{_javadir}-1.4.0/jce.jar
%{_javadir}-1.4.1/jce.jar
%{_javadir}-1.4.2/jce.jar
%{_javadir}/gcj-endorsed/%{name}-jce-jdk1.4.jar
%endif

%files javadoc
%defattr(644,root,root,755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Thu May 26 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:2.0.1-1jpp_5fc
- Separate post and postun lines.
- Require libgcj, not gcc-java.

* Mon May 16 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:2.0.1-1jpp_4fc
- Require jpackage-utils for post and postun.
- Run rebuild-security-providers with full path.

* Thu Apr 21 2005 Gary Benson <gbenson@redhat.com> - 0:2.0.1-1jpp_3fc
- Put the sasl endorsed jar in the correct subpackage.

* Wed Apr 13 2005 Thomas Fitzsimmons <fitzsim@redhat.com> - 0:2.0.1-1jpp_2fc
- Add gcj endorsed dir support.
- Add GnuCrypto security provider to classpath.security.

* Thu Nov  4 2004 Gary Benson <gbenson@redhat.com> - 0:2.0.1-1jpp_1fc
- Build into Fedora.

* Mon Jun 14 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0.1-1jpp
- First build.
